
// https://css-tricks.com/snippets/css/a-guide-to-flexbox/

[layout] {
  &[horizontal] {
    display: flex;
    flex-direction: row;
  }
  &[horizontal-reverse] {
    display: flex;
    flex-direction: row-reverse;
  }
  &[vertical] {
    display: flex;
    flex-direction: column;
  }
  &[vertical-reverse] {
    display: flex;
    flex-direction: column-reverse;
  }

  &[inline] {
    display: inline-flex;
  }

  &[wrap] {
    flex-wrap: wrap;
  }
  &[wrap-reverse] {
    flex-wrap: wrap-reverse;
  }

  &[align-start] {
    align-items: flex-start;
  }
  &[align-center] {
    align-items: center;
  }
  &[align-end] {
    align-items: flex-end;
  }
  &[align-baseline] {
    align-items: baseline;
  }
  &[align-stretch] {
    align-items: stretch;
  }

  &[flex-left] {
    justify-content: flex-start;
  }
  &[flex-center] {
    justify-content: center;
  }
  &[flex-end] {
    justify-content: flex-end;
  }
  &[flex-stretch-with-space] {
    justify-content: space-around;
  }
  &[flex-stretch] {
    justify-content: space-between;
  }
}

[flex-auto] {
    flex: 1 1 auto;
}

[flex-none] {
    flex: none;
}


@mixin flex($amount) {
  flex: $amount;
}

[flex] {
  @include flex(1);
}
@for $i from 1 through 12 {
  [flex-#{$i}] {
    @include flex($i);
  }
  [order-#{$i}] {
    order: $i;
  }
}

[self-start] {
    align-self: flex-start;
}
[self-center] {
    align-self: center;
}
[self-end] {
    align-self: flex-end;
}
[self-stretch] {
    align-self: stretch;
}
[self-baseline] {
    align-self: baseline;
}
/*******************************
Other Layout
*******************************/

[block] {
    display: block;
}

/* IE 10 support for HTML5 hidden attr */
[hidden] {
    display: none !important;
}

[invisible] {
    visibility: hidden !important;
}

[relative] {
    position: relative;
}

[fit] {
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
}

[body][fullbleed] {
    margin: 0;
    height: 100vh;
}

[scroll] {
    -webkit-overflow-scrolling: touch;
    overflow: auto;
}
/* fixed position */

[fixed-bottom],
[fixed-left],
[fixed-right],
[fixed-top] {
    position: fixed;
}

[fixed-top] {
    top: 0;
    left: 0;
    right: 0;
}

[fixed-right] {
    top: 0;
    right: 0;
    bottom: 0;
}

[fixed-bottom] {
    right: 0;
    bottom: 0;
    left: 0;
}

[fixed-left] {
    top: 0;
    bottom: 0;
    left: 0;
}
